program dostava;

const MAXN = 100000;

var
   i, j, n, k : longint;
   vrijeme, trenutna, sljedeca : longint;
   rjesenje : int64;
   kumulativnaSuma : array[1..3,0..MAXN+1] of int64;

function min2( x, y : int64 ) : int64;
begin
   if x < y then min2 := x else min2 := y;
end;

function suma( ulica, a, b : longint ) : int64;
var
   t : longint;
begin
   if a > b then begin t := a; a := b; b := t; end;
   suma := kumulativnaSuma[ulica][b] - kumulativnaSuma[ulica][a];
end;

function ulica( lokacija : longint ) : longint;
begin
   if (lokacija = 1) or (lokacija = 3*n+2) then ulica := 1
   else ulica := (lokacija-2) div n + 1;
end;

function redniBroj( lokacija : longint ) : longint;
begin
   if lokacija = 1 then redniBroj := 0
   else if lokacija = 3*n+2 then redniBroj := n+1
   else redniBroj := (lokacija-2) mod n + 1;
end;

function najkraciPut( lokacijaA, lokacijaB : longint ) : int64;
var
   uA, rbA : longint;
   uB, rbB : longint;
   uc : longint;
   ret : int64;
begin
   uA := ulica( lokacijaA ); rbA := redniBroj( lokacijaA );
   uB := ulica( lokacijaB ); rbB := redniBroj( lokacijaB );

   ret := 1000000000000000;

   (* 1) A -> B (uz uvjet da su u istoj ulici) *)
   if uA = uB then ret := min2( ret, suma( uA, rbA, rbB ) );

   (* 2) A -> lijevi trg -> B *)
   ret := min2( ret, suma( uA, rbA, 0 ) + suma( uB, 0, rbB ) );

   (* 3) A -> desni trg -> B *)
   ret := min2( ret, suma( uA, rbA, n+1 ) + suma( uB, n+1, rbB ) );

   (* 4) A -> lijevi trg -> desni trg -> B *)
   for uc := 1 to 3 do
      ret := min2( ret, suma( uA, rbA, 0 ) + suma( uC, 0, n+1 ) + suma( uB, n+1, rbB ) );

   (* 5) A -> desni trg -> lijevi trg -> B *)
   for uc := 1 to 3 do
      ret := min2( ret, suma( uA, rbA, n+1 ) + suma( uC, n+1, 0 ) + suma( uB, 0, rbB ) );

   najkraciPut := ret;
end;

begin
   readln( n );
   for i := 1 to 3 do begin
      kumulativnaSuma[i,0] := 0;
      for j := 0 to n do begin
         read( vrijeme );
         kumulativnaSuma[i,j+1] := kumulativnaSuma[i,j] + vrijeme;
      end;
      readln;
   end;

   rjesenje := 0;
   trenutna := 1;
   sljedeca := 0;

   readln( k );
   for i := 1 to k do begin
      read( sljedeca );

      rjesenje := rjesenje + najkraciPut( trenutna, sljedeca );

      trenutna := sljedeca;
   end;
   writeln( rjesenje );
end.
